/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sbd;

import java.io.Serializable;
import java.sql.Connection;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.Vector;

/**
 *
 * @author luzem
 */
public class baseCommand implements Serializable{

    protected Vector<String> parameterList;
    public String userName;
    public String password;
    public String Filename;
    protected String help;
    public boolean toFile;
    protected boolean isAdminCommand;
    protected boolean isUserCommand;

    /**
     * Creates a new baseCommand
     */
    public baseCommand() 
    {
        parameterList=new Vector<String>();
        toFile=false;
        isAdminCommand=false;
        isUserCommand=false;
    }


    /**
     * Executes the command
     * @return a String with the results
     */
    public String execute() {
        return "";
    }

    /**
     * Check if the command need to be saved in a File
     * @return true if need be saved
     */
    public boolean saveToFile()
        {
        return isToFile();
        }

    /**
     * Add's a parameter in the command parameterList
     * @param parameter
     */
    public void addParameter(String parameter) {
        parameterList.add(parameter);
    }

    /**
     * Get a conexión to the database
     * @return the database Connection
     */
    protected Connection getConnection() {
        //TODO pharsear archivo para implementar independencia del driver
        Connection toret = null;
        try {
            //toret = DriverManager.getConnection("jdbc:mysql://localhost/proa?", "root", "");
            toret = DriverManager.getConnection("jdbc:mysql://localhost/javatrack");
        } catch (SQLException ex) {
            System.out.println("SQLException: " + ex.getMessage());
            System.out.println("SQLState: " + ex.getSQLState());
            System.out.println("VendorError: " + ex.getErrorCode());
        }
        return toret;
    }

    /**
     * Get bug inserTode
     * @return the max code value in the bug table
     */
    public int getBugMaxCodeValue() {
        int toret = 0;
        Connection con;
        con = getConnection();
        Statement stmt = null;
        ResultSet rs = null;
        try {
            stmt = con.createStatement();
            rs = stmt.executeQuery("select max(codigo) from bugs");
            rs.first();
            toret = rs.getInt(1);
            toret++;
            con.close();
        } catch (SQLException sqle) {
            System.out.println("SQLException: " + sqle.getMessage());
            System.out.println("SQLState: " + sqle.getSQLState());
            System.out.println("VendorError: " + sqle.getErrorCode());
        }
        return toret;
    }

    /**
     * Check if the username exist in the database
     * @param user the username
     * @return true if exist and it's enabled
     */
    public boolean isValidUsername(String user) {
        boolean toret = false;
        Connection con;
        con = getConnection();
        Statement stmt = null;
        ResultSet rs = null;
        try {
            stmt = con.createStatement();
            rs = stmt.executeQuery("select * from usuarios where login='" + user + "'");
            rs.last();
            int count = rs.getRow();
            if (count > 0) {
                toret = true;
            }
            con.close();
        } catch (SQLException sqle) {
            System.out.println("SQLException: " + sqle.getMessage());
            System.out.println("SQLState: " + sqle.getSQLState());
            System.out.println("VendorError: " + sqle.getErrorCode());
        }
        return toret;
    }

        /**
         * check if the username and password is valid
         * @return true if it's valid
         */
        public boolean verifyLogin()
        {
        return isValidUsernamePassword(userName,password);
        }


    /**
     * Check if a username and password is valid
     * @param user the username to verify
     * @param password the password to verify
     * @return true if it's a correct username and password
     */
    public boolean isValidUsernamePassword(String user, String password) {
        boolean toret = false;
        Connection con;
        con = getConnection();
        Statement stmt = null;
        ResultSet rs = null;
        try {
            stmt = con.createStatement();
            rs = stmt.executeQuery("select * from usuarios where login='" + user + "' and password='" + password + "'");
            rs.last();
            int count = rs.getRow();
            if (count > 0) {
                toret = true;
            }
            con.close();
        } catch (SQLException sqle) {
            System.out.println("SQLException: " + sqle.getMessage());
            System.out.println("SQLState: " + sqle.getSQLState());
            System.out.println("VendorError: " + sqle.getErrorCode());
        }
        return toret;
    }

    /**
     * Check's if the username exist in the users table
     * @param user the username to check
     * @return true if exist
     */
    public boolean existUser(String user) {
        boolean toret = false;
        Connection con;
        Statement stmt = null;
        ResultSet rs = null;

        con = this.getConnection();
        try {
            stmt = con.createStatement();
            rs = stmt.executeQuery("select * from usuarios where login='" + user + "'");
            int count = 0;
            while (rs.next()) {
                count++;
            }
            if (count > 0) {
                toret = true;
            }
            con.close();
        } catch (SQLException sqle) {
            System.out.println("SQLException: " + sqle.getMessage());
            System.out.println("SQLState: " + sqle.getSQLState());
            System.out.println("VendorError: " + sqle.getErrorCode());
        }
        return toret;
    }

    /**
     * Executes a update SQL command
     * @param SQL the SQL instruccion
     * @return true if exit
     */
    public boolean executeUpdate(String SQL)
        {
        boolean toret=false;
        try
            {
            System.out.println("ExecuteUpdate:"+SQL);
            Connection conn;
            conn=this.getConnection();
            Statement st=conn.createStatement();
            st.executeUpdate(SQL);
            st.close();
            conn.close();
            toret=true;
            }
        catch(SQLException sqle)
            {
            System.out.println("SQLException: " + sqle.getMessage());
            System.out.println("SQLState: " + sqle.getSQLState());
            System.out.println("VendorError: " + sqle.getErrorCode());
            }
        return toret;
        }

       /**
        * Executes a delete SQL command
        * @param SQL the SQL delete command
        * @return true if there's no problems in the execution
        */
       public boolean executeDelete(String SQL)
        {
        boolean toret=false;
        try
            {
            System.out.println("ExecuteDelete:"+SQL);
            Connection conn;
            conn=this.getConnection();
            Statement st=conn.createStatement();
            st.execute(SQL);
            st.close();
            conn.close();
            toret=true;
            }
        catch(SQLException sqle)
            {
            System.out.println("SQLException: " + sqle.getMessage());
            System.out.println("SQLState: " + sqle.getSQLState());
            System.out.println("VendorError: " + sqle.getErrorCode());
            }
        return toret;
        }

    /**
     * Exdecutes a insert SQL command
     * @param SQL the SQL inser command
     * @return a String with the error or exit
     */
    public String executeInsert(String SQL)
        {
        String toret="";
        try
            {
            System.out.println("ExecuteInsert:"+SQL);
            Connection conn;
            conn=this.getConnection();
            Statement st=conn.createStatement();
            st.execute(SQL);
            st.close();
            conn.close();
            toret="Register Inserted";
            }
        catch(SQLException sqle)
            {
            System.out.println("SQLException: " + sqle.getMessage());
            System.out.println("SQLState: " + sqle.getSQLState());
            System.out.println("VendorError: " + sqle.getErrorCode());
            toret="Error inserting in the database";

            }
        return toret;
        }

    /**
     * Get's a select SQL query
     * @param SQL the SQL query
     * @return the result of the query
     */
    public String getSelectQuery(String SQL)
        {
        String toret="";
        try{
        System.out.println("getSelectQuery:"+SQL);
        Connection conn;
        ResultSet rs;
        conn=this.getConnection();
        Statement st=conn.createStatement();
        st.executeQuery(SQL);
        rs=st.getResultSet();
        toret+=getResultSetMetaDataHeader(rs.getMetaData());
        toret+=getResultSetLines(rs);
        rs.close();
        st.close();
        conn.close();
        }catch(SQLException sqle)
            {
            System.out.println("SQLException: " + sqle.getMessage());
            System.out.println("SQLState: " + sqle.getSQLState());
            System.out.println("VendorError: " + sqle.getErrorCode());
            toret="Error querying database";
            }

        return toret;
        }

    /**
     * Get a resultSet formated for print in the screen
     * @param rs the resultset for print
     * @return a String that represents the resultset
     */
    public String getResultSetLines(ResultSet rs) {
        String toret = "";
        try {
            ResultSetMetaData rsmd;
            rs.first();
            rsmd = rs.getMetaData();
            do {
                for (int x = 1; x <= rsmd.getColumnCount(); x++) {
                    toret += rs.getString(x) + "\t";
                }
                toret += "\n";
            } while (rs.next());
        } catch (SQLException sqle) {
            System.out.println("getResultSetLines");
            System.out.println("SQLException: " + sqle.getMessage());
            System.out.println("SQLState: " + sqle.getSQLState());
            System.out.println("VendorError: " + sqle.getErrorCode());
        }
        return toret;
    }

    /**
     * Get the resultSet fieldNames for screen print
     * @param rsmd the resultserMetaData
     * @return a String with the field's names
     */
    public String getResultSetMetaDataHeader(ResultSetMetaData rsmd) {
        String toret = "";
        try {
            for (int x = 1; x <= rsmd.getColumnCount(); x++) {
                toret += rsmd.getColumnName(x) + "\t";
                System.out.print(rsmd.getColumnName(x) + "\t");
                System.out.println();
            }
        } catch (SQLException sqle) {
            System.out.println("SQLException: " + sqle.getMessage());
            System.out.println("SQLState: " + sqle.getSQLState());
            System.out.println("VendorError: " + sqle.getErrorCode());
        }
        toret += "\n";
        return toret;
    }

    /**
     * check if the bugCode is solved
     * @param bugCode the bugCode id
     * @return true if solved false otherwise
     */
    public boolean isBugSolved(int bugCode)
        {
        boolean toret=false;
        //SELECT programador from bugs where codigo=bugCode
        try {
            Connection con;
            String bugStatus;
            con=this.getConnection();
            Statement st;
            ResultSet rs;
            st=con.createStatement();
            st.execute("SELECT estado from bugs where codigo="+bugCode);
            rs=st.getResultSet();
            if (!rs.first())
                {
                System.out.println("Invalid bug code");
                }
            else
                {
                bugStatus=rs.getString(1);
                System.out.println("bugStatus =="+bugStatus+"||");
                if (bugStatus.equals("RESUELTO"))
                    {
                    System.out.println("Cambiando valor de toret");
                    toret=true;
                    }
                }
            }catch (SQLException sqle) {
            System.out.println("SQLException: " + sqle.getMessage());
            System.out.println("SQLState: " + sqle.getSQLState());
            System.out.println("VendorError: " + sqle.getErrorCode());
        }
        return toret;
        }

    /**
     * Check if the bugCode exist in the table
     * @param bugCode the bugcode to check
     * @return true if exist
     */
    public boolean existBug(int bugCode)
        {
        boolean toret=false;
        try
            {
            String SQL="SELECT * FROM bugs where codigo="+bugCode;
            Connection con;
            con=this.getConnection();
            Statement st;
            ResultSet rs;
            st=con.createStatement();
            st.executeQuery(SQL);
            rs=st.getResultSet();
            if (rs.first())
                {
                toret=true;
                }
            }
        catch(SQLException sqle)
            {
            System.out.println("SQLException: " + sqle.getMessage());
            System.out.println("SQLState: " + sqle.getSQLState());
            System.out.println("VendorError: " + sqle.getErrorCode());
            }
        return toret;
        }

    /**
     * Get the programmer asociated to a bug code
     * @param bugCode the bugCode ID
     * @return the user asociated to the bugCode
     */
    public String getBugProgrammer(int bugCode)
        {
        String toret="";
        //SELECT programador from bugs where codigo=bugCode
        try {
            Connection con;
            con=this.getConnection();
            Statement st;
            ResultSet rs;
            st=con.createStatement();
            st.execute("SELECT programador from bugs where codigo="+bugCode);
            rs=st.getResultSet();
            if (!rs.first())
                {
                System.out.println("Invalid bug code");
                }
            else
                {
                toret=rs.getString(1);
                }
            }catch (SQLException sqle) {
            System.out.println("SQLException: " + sqle.getMessage());
            System.out.println("SQLState: " + sqle.getSQLState());
            System.out.println("VendorError: " + sqle.getErrorCode());
        }
        return toret;
        }

    /**
     * Check if a username is admin
     * @param user the username
     * @return true if the username is admin
     */
    public boolean isAdminUsername(String user) {
        boolean toret = false;
        Connection con;
        Statement stmt = null;
        ResultSet rs = null;

        con = this.getConnection();
        try {
            stmt = con.createStatement();
            rs = stmt.executeQuery("select * from usuarios where login='" + user + "'and administrador=1");
            rs.last();
            int count = rs.getRow();
            if (count > 0) {
                toret = true;
            }
            con.close();
        } catch (SQLException sqle) {
            System.out.println("SQLException: " + sqle.getMessage());
            System.out.println("SQLState: " + sqle.getSQLState());
            System.out.println("VendorError: " + sqle.getErrorCode());
        }
        return toret;
    }

    /**
     * @return the user
     */
    public String getUserName() {
        System.out.println("returning Username:"+userName);
        return userName;
    }

    /**
     * @param user the user to set
     */
    public void setUserName(String user) {
        System.out.println("setting Username:"+user);
        this.userName = user;
    }

    /**
     * @return the pass
     */
    public String getPassword() {
        System.out.println("returning Password:"+password);
        return password;
    }

    /**
     * @param pass the pass to set
     */
    public void setPassword(String pass) {
        System.out.println("Setting password:"+pass);
        this.password = pass;
    }

    /**
     * return the help String associated to the command
     * @return help String associated to the command
     */
    public String getHelp()
        {
        return help;
        }


    /**
     * Check if the command has permisions to be exuted
     * @return true is have permissions
     */
    public boolean havePermisionstoExecuteCommand()
        {
        boolean toret=false;
        if (isAdminUsername(userName) && isAdminCommand)
            {
            toret=true;
            }
        if ( !(isAdminUsername(userName)) && isUserCommand)
            {
            toret=true;
            }
        return toret;
        }

    /**
     * return a parameter from the Command
     * @param index the index of parameter
     * @return a String that contains the parameter
     */
    public String getParameterAt(int index)
        {
        return parameterList.elementAt(index);
        }

    /**
     * @return the toFile
     */
    public boolean isToFile() {
        return toFile;
    }

    /**
     * @return the Filename
     */
    public String getFilename() {
        return Filename;
    }
}
