/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sjavatrack;

import java.util.StringTokenizer;
import java.net.*;
import java.io.*;
import java.rmi.Naming;
import java.util.logging.Level;
import java.util.logging.Logger;
import sbd.Compute;
import sbd.baseCommand;
/**
 *
 * @author luzem
 */
public class socketThread extends Thread {

    /**
     * the socket used to mantains the communication with the client
     */
    private Socket socket = null;

    /**
     * Creates a new socket thread
     * @param socket the socket connection tath listen
     */
    public socketThread(Socket socket) {
        super();
        this.socket = socket;
    }
    


    @Override
    public void run()
        {
        String username=null;
        String password=null;
        String clientMessage="";
        String receivedMessage="";
        StringTokenizer st;
        String commandtoExecute;
        Class comandClass;
        baseCommand obtainedCommand;
        CommandOutput co;
        co =new CommandOutput(false,null,"");
        System.out.println("Running a Thread");
        while (!socket.isClosed() )
            {
            receivedMessage = readClient();
            System.out.println("Received message:"+receivedMessage);
            if (!receivedMessage.equals(""))//case not whitespaces
                {
                st=new StringTokenizer(receivedMessage);
                commandtoExecute=st.nextToken();
                try
                    {
                    System.out.println("Command to Execute:"+commandtoExecute+":");
                    if (commandtoExecute.equals("help"))//case help
                        {
                        System.out.print("Help command\n");
                        if (st.hasMoreTokens())
                            {
                            comandClass = Class.forName("sjavatrack.commands." + st.nextToken() );
                            }
                        else
                            {
                            comandClass = Class.forName("sjavatrack.commands." + commandtoExecute);
                            }
                        }
                    else
                        {
                        comandClass = Class.forName("sjavatrack.commands." + commandtoExecute);
                        }
                    obtainedCommand = (baseCommand) comandClass.newInstance();
                    //Adding parameters
                    while (st.hasMoreElements())
                        {
                        obtainedCommand.addParameter(st.nextToken());
                        }
                    obtainedCommand.setUserName(username);
                    obtainedCommand.setPassword(password);
                    if (commandtoExecute.equals("help"))
                        {
                        clientMessage=obtainedCommand.getHelp();
                        }
                    else
                        {
                        try {
                            //System.out.println("Checking permissions");
                            //System.out.println("Username ="+ username);
                        if (remotePermisionsCheck(obtainedCommand))//Check permissions
                            {
                                //clientMessage=obtainedCommand.execute();//Execute
                                clientMessage = remoteExecute(obtainedCommand);
                                if (obtainedCommand.isToFile())
                                    {
                                    co.setToFile(true);
                                    co.setFilename(obtainedCommand.getFilename());
                                    }

                            }
                        else
                            {
                            clientMessage="ERROR invalid permisions";
                            }
                        } catch (Exception ex) {
                                ex.printStackTrace();
                                closeSocket();
                                break;
                            }
                        }
                    if (commandtoExecute.equals("login"))
                        {
                        System.out.println("Initializeing login variables log="+obtainedCommand.verifyLogin());
                        try
                            {
                            if (clientMessage.equals("Login successful"))
                                {
                                System.out.println("Changuing login variables values");
                                System.out.println("Username:"+ obtainedCommand.getParameterAt(0));
                                System.out.println("Password:"+ obtainedCommand.getParameterAt(1));
                                username=obtainedCommand.getUserName();
                                password=obtainedCommand.getPassword();
                                }
                            }
                        catch(Exception e)
                            {
                            System.out.println(e.toString());
                            closeSocket();
                            }
                        }
                    }
                catch (ClassNotFoundException cnfe)
                            {
                            clientMessage="Command not found use help for list";
                            }
                       catch (InstantiationException ie)
                            {
                            clientMessage=ie.toString();
                            }
                       catch (IllegalAccessException iae)
                            {
                            clientMessage=iae.toString();
                            }
                }
            co.setResponse(clientMessage);
            sendCommandOutput(co);
            //Reinitializa values
            co.setFilename("");
            co.setToFile(false);
            co.setResponse("");
            }
          System.out.println("Ending Thread");
        }


    /**
     * Check permisions of the baseCommand
     * @param bc the base command
     * @return true if the user attached to the command works
     * @throws Exception
     */
    private boolean remotePermisionsCheck(baseCommand bc) throws Exception
        {
        boolean toret=false;
         if (System.getSecurityManager() == null)
            {
            System.setSecurityManager(new SecurityManager());
            }
        String name = "ComputeEngine";
        Compute ce= (Compute) Naming.lookup("//localhost:1099/"+name);
        toret=ce.hasPermisions(bc);
        System.out.println("Permissions check gives "+toret);
        return toret;
        }

    /**
     * Execute's a base command in the remote server
     * @param bc baseCommand to execute
     * @return the baseCommand result
     * @throws Exception
     */
        private String remoteExecute(baseCommand bc) throws Exception
        {
        String toret="";
         if (System.getSecurityManager() == null)
            {
            System.setSecurityManager(new SecurityManager());
            }

            String name = "ComputeEngine";
            Compute ce= (Compute) Naming.lookup("//localhost:1099/"+name);
            toret=ce.execute(bc);

        return toret;

        }

    private boolean remoteVerify(baseCommand bc) throws Exception
        {
        boolean toret=false;
         if (System.getSecurityManager() == null)
            {
            System.setSecurityManager(new SecurityManager());
            }
            String name = "ComputeEngine";
            Compute ce= (Compute) Naming.lookup("//localhost:1099/"+name);
            toret=ce.verifyLogin(bc);

        return toret;

        }

    /**
     * Read clients data
     * @return the clients data
     */
    private String readClient() {
        String toret = null;
        try {
            InputStream aux = socket.getInputStream();
            DataInputStream flow = new DataInputStream(aux);
            toret = flow.readUTF();
            //System.out.println(toret);
            } catch (java.io.IOException ioe) {
            System.out.println("SocketThread readClient()");
            System.out.println(ioe.toString());
            closeSocket();
            toret = "";
            
        }
        return toret;
    }

    /**
     * close the thread socket
     */
    private void closeSocket()
        {
        try{
            socket.close();
            }
        catch(java.io.IOException ioe)
            {
            System.out.println("Closing socket");
            }
        }

    /**
     * Send a CommandOutput to the client
     * @param co the CommandOutput
     */
    private void sendCommandOutput(CommandOutput co)
        {
        try {
            OutputStream os = socket.getOutputStream();
            ObjectOutputStream oos = new ObjectOutputStream(os);
            oos.writeObject(co);
            //oos.close();
            }
        catch (IOException ex)
            {
            Logger.getLogger(socketThread.class.getName()).log(Level.SEVERE, null, ex);
            }

        }

    
    private void sendMessage(String message) {
        try {
            OutputStream stream = socket.getOutputStream();
            DataOutputStream flow = new DataOutputStream(stream);
            flow.writeUTF(message);
        } catch (java.io.IOException ioe) {
            System.out.println(ioe.toString());
            this.interrupt();
        }
    }
}
